/*
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.aircraft.generate;

import com.aircraft.utils.StringUtils;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import lombok.AllArgsConstructor;

import java.util.Arrays;

/**
 * <p>
 * Mysql代码生成器
 * </p>
 */
public class MysqlGenerator extends SuperGenerator {

    /**
     * <p>
     * MySQL generator
     * </p>
     */
    public void generator(String tableName, String tablePrefix, String moduleName) {
        if (StringUtils.isBlank(moduleName)){
            moduleName = "system";
        }


        // 代码生成器
        AutoGenerator mpg = getAutoGenerator(tableName, tablePrefix, moduleName);
        mpg.execute();
        if (tableName == null) {
            System.err.println(" Generator Success !");
        } else {
            System.err.println(" TableName【 " + tableName + " 】" + "Generator Success !");

        }
    }

    @AllArgsConstructor
    public static class tableInfo {
        private String tableName;
        private String tablePrefix;
        private String moduleName;
    }

    public static void main(String[] args) {
        MysqlGenerator mysqlGenerator = new MysqlGenerator();
        Arrays.asList(
                //表名，去除前缀，模块名
                new tableInfo("fms_ac_aircraft_device","fms_ac_","aircraft"),
                new tableInfo("fms_ac_aircraft_device","fms_ac_","aircraft")
        ).forEach(tableInfo -> {
            mysqlGenerator.generator(tableInfo.tableName, tableInfo.tablePrefix, tableInfo.moduleName);
        });
    }

}
